#include <iostream>
#include <string>
//mora includovati Osoba.h
#include "Osoba.h";
using namespace std;

int main(){

	//obicna promenljiva - Promenljiva koja sadrzi neku vrednost i smestena je negde u memoriji
	int broj = 5;
	//prisutpi adresi te promenljive
	cout<< &broj <<endl; // znak & adresni prostor
	//pokazivac. Predstavlja promenljivu koji kao vrednost sadrzi memorijsku adresu
	int *pokazivac = &broj;
	cout<<pokazivac <<endl;//smestamo memorijsku adresu u pokazivac(pointer) koji pokazuje sad na tu memorijsku adresu
	//pointer je dovoljno jednom napisati sa zvezdicom, svaki put posle toga ide bez zvezdice.
	

	//metod sizeof(); meri velicinu promenljive koliko bajtova zauzima, broji koliko jedan niz ima elemenata
	char c;
	int b; 

	int number = 123;
	cout<<"Velicina promenljive number je : "<< sizeof(number)<<endl;
	int *pnumber = &number; // dodeljujemo memorijsku adresu kao vrednost pokazivacu *nubmer
	cout<<"Velicina pokazivaca *pnumber je: "<<sizeof(*pnumber) <<endl;
	 
	//provera koliko niz ima elemenata pomocu sizeof() metoda
	
	int niz2[] = {5,2,10,58,23,12,51};
	int velicina = sizeof(niz2) / sizeof(*niz2); // 28 bajtova / 4 bajta = 7. i taj rezultat 7 je broj elemenata niza smesten u promenljivu velcina
	//ako iskoristimo samo ime niza niz2
	cout<<"Koristenje imena niza: "<<sizeof(niz2)<<endl; // rezultat ce biti 7 elemata * 4 bajta = 28 bajtova
	cout<<"Koristenje pokazivaca na prvi element niza" <<sizeof(*niz2)<<endl; // rezultat ce biti 4 bajta, jer toliko sadrzi svaki element tipa int
	cout<<"Broj elemenata niza je: "<<velicina <<endl; // ispisuje broj elemenata niza

	cout<<sizeof(c) <<endl; // 1 bajt  velicina
	cout<<sizeof(b) <<endl; // 4 bajta

	//1. niz zadatak
	const int velicinaNiza = 4;
	int niz[velicinaNiza] = {5,10,15,20};
	
	for(int i=0; i<velicinaNiza; i++){
		//standardno ispisivanje elemenata
		cout<<niz[i] <<endl;
	}

	//kreiranje pokazivaca na prvi element niza
	int *pNiz = &niz[0]; // u pokazivac smestamo ADRESU prvog elementa niza
	cout<< *pNiz <<endl;

	// nakon pristupa prvo elementu niza mozemo pristupiti i drugom elementu niza pomocu pokazivaca
	cout<< *(pNiz + 1) <<endl; // * pa u zagradi pokazivac + 1 , sto znaci sledeci element u nizu

	// mozemo napraviti i petlju i prikazati elemente niza pomocu pokazivaca
	
	cout<<"Elementi prikazani pomocu pokazivaca "<<endl;
	for(int i=0; i<velicinaNiza; i++){
		cout<< *(pNiz + i) <<endl;
	}


	// u kodu iznad ime niza je pokazivac na prvi element niza

	//moze se koristiti samo ime niza sa zvezdicom i dobice se prvi element niza
	cout<<"Pristup prvom elemntu niza koristeci ime niza kao pokazivac "<<endl;
	cout<< *niz <<endl; // prikazace prvi element niza

	//ispis svih elemenata niza koristcei ime niza kao pokazivac. PREDNOST POKAZIVACA JE da mi mozemo koristiti samo ime niza za pristup njegovim elementima
	cout<<"Ispis svih elemenata niza koristeci ime niza kao pokazivac" <<endl;
	for(int i=0; i<velicinaNiza; i++){
	cout<< *(niz + i)<<endl;
	}


	//zadatak 1

	/*
	Definisanti niz. Broj elemenata uneti preko tastature. Ispisati sve elemente niza koristeci ime niza kao pokazivac. 
	Prebrojati sve elemente niza i prikazati koliko ih ima.

	*/
	
	  int arraySize;
	  cout<<"Unesite broj elemenata niza: "<<endl;
	  cin>>arraySize;

	  int *niz3 = new int[arraySize];

	 for(int i=0; i<arraySize; i++){
		 cout<<"Unesite element niza"<<endl;
		 cin>> niz3[i];
		 
		
	 }
	 for(int i=0; i<arraySize; i++){

		  cout<<*(niz3 + i)<<endl;
	 }
	 
	 



	 //KLASE I OBJEKTI
	Osoba o;
	o.ime = "Pera";
	o.prezime = "Peric";
	o.brojIndeksa = "12345";

	o.polaganjeKolokvijuma();
	o.polaganjeIspita();
	o.ispisiPodatke();

	system("pause");
	return 0;

}